#!/usr/bin/perl -w
#you need to install DBI-mysql for this script to work.
# Author: Jim Michaels
# Creation Date: June 20, 2009
# Current Date: June 20, 2009
# Abstract: log work hours.
#
# Copyright 1999,2006,2007,2009 Jim Michaels
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.

use English;
require Tk;
use Tk;
#require DBI;
use DBI;
use POSIX qw(locale_h);

#--------------------------user settings
my $Version="1.1";
my $dbname='mysampledbname';
my $dbport='5432';
my $dbhost='localhost';
my $dbuid='mydbusername';
my $dbpwd='mydbpassword';
my $dbschema='myschemaname';
my $timezonecity="America/Vancouver";
#--------------------------end user settings


my $dbistr="DBI:PgPP:dbname=$dbname;port=$dbport;host=$dbhost";

#$old_locale=setlocale(LC_CTYPE);
setlocale(LC_CTYPE,"en-US");

#-----local database variables
my $church=1;
my $satisfied=1;

#create window
my $main=MainWindow->new();
$main->minsize( qw(500 250));
$main->title("Task Timer");
$main->configure(-background=>'cyan');


#create frames
my $top=$main->Frame(-background=>'cyan')->pack(-side=>'top',-fill=>'x');

my $lin=$main->Frame(-borderwidth=>3,-relief=>'groove',-background=>'blue')->pack(-side=>'top');
my $stat1=$lin->Label(-text=>'Press the update tasknum button to get the value',-width=>59,-height=>0,-foreground=>'white',-background=>'blue')->pack();
my $stat2=$lin->Label(-text=>'(based on name,project) from the database+1',-width=>59,-height=>0,-foreground=>'white',-background=>'blue')->pack();
#my $mid=$main->Frame(-background=>'cyan',-anchor=>'w')->pack(-side=>'top',-fill=>'y',-expand=>'y');
my $mid=$main->Frame(-background=>'cyan')->pack(-side=>'top',-fill=>'y',-expand=>'y');
my $left1=$mid->Frame(-background=>'cyan')->pack(-side=>'left');#,pady=>9,padx=>8);
my $right2=$mid->Frame(-background=>'cyan')->pack(-side=>'left',-pady=>2,-padx=>2);
my $right3=$mid->Frame(-background=>'cyan')->pack(-side=>'left',-pady=>2,-padx=>2);

#create form fields
my $t1=$left1->Label(-text=>'start time')->pack(-anchor=>'e');
my $ent_starttime=$right2->Entry(-width=>40,-background=>'white')->pack(-anchor=>'w',-pady=>1); #start time
$ent_starttime->insert('end',"2009-03-13 14:00:00 $timezonecity");

my $t2=$left1->Label(-text=>'end time')->pack(-anchor=>'e');
my $ent_endtime=$right2->Entry(-width=>40,-background=>'white')->pack(-anchor=>'w',-pady=>1); #end time
$ent_endtime->insert('end',"2009-03-13 15:00:00 $timezonecity");

my $t3=$left1->Label(-text=>'project')->pack(-anchor=>'e');
my $ent_prj=$right2->Entry(-width=>20,-background=>'white')->pack(-anchor=>'w',-pady=>1); #prj
$ent_prj->insert('end',"comp repair");

my $t4=$left1->Label(-text=>'name')->pack(-anchor=>'e');
my $ent_name=$right2->Entry(-width=>20,-background=>'white')->pack(-anchor=>'w',-pady=>1); #name
$ent_name->insert('end',"Jim");

my $t5=$left1->Label(-text=>'tasknum')->pack(-anchor=>'e');
my $ent_tasknum=$right2->Entry(-width=>10,-background=>'white')->pack(-anchor=>'w',-pady=>1); #tasknum
$ent_tasknum->insert('end',"1");

my $right4=$mid->Frame(-background=>'cyan',)->pack(-side=>'right',-fill=>'y');
# my $ckbtn_church=$right4->Checkbutton(-variable=>\$church,-text=>'church',-borderwidth=>2,-relief=>'groove',height=>3)->pack(-side=>'top',-pady=>2,-fill=>'x',-anchor=>'w');
my $ckbtn_church=$right4->Checkbutton(-variable=>\$church,-text=>'church',-borderwidth=>2,-height=>3)->pack(-side=>'top',-pady=>2,-fill=>'x',-anchor=>'w');
my $ckbtn_satisfied=$right4->Checkbutton(-variable=>\$satisfied,-text=>'satisfied',-borderwidth=>2,-height=>3)->pack(-side=>'top',-pady=>2,-fill=>'x',-anchor=>'w');


my $btn_updent=$right3->Button(-text=>'Update tasknum',-command=>[\&upd_ent],-background=>'red',-foreground=>'white')->pack();
my $btn_starttime=$right3->Button(-text=>'Update Start Time',-command=>[\&chg_starttime],-foreground=>'red')->pack();
my $btn_endtime=$right3->Button(-text=>'Update End Time',-command=>[\&chg_endtime],-foreground=>'red')->pack();
my $btn_tasknum=$right3->Button(-text=>'tasknum++',-command=>[\&incr_tasknum],-foreground=>'red')->pack();
my $t6=$right3->Label(-text=>'',-background=>'cyan')->pack();
my $btn_upddb=$right3->Button(-text=>'Update Database',-command=>[\&upd_db],-background=>'red',-foreground=>'white')->pack();
my $t7=$right3->Label(-text=>'',-background=>'cyan')->pack();
my $btn_crtdb=$right3->Button(-text=>'Create Database',-command=>[\&crt_db],-background=>'red',-foreground=>'white')->pack();


MainLoop();
sub chg_starttime {
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime();
    $year+=1900;
    $mon++;
    $datestr="$year-$mon-$mday $hour:$min:$sec $timezonecity";
    $ent_starttime->delete(0,19);
    $ent_starttime->insert('end',$datestr);
}
sub chg_endtime {
    ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime();
    $year+=1900;
    $mon++;
    $datestr="$year-$mon-$mday $hour:$min:$sec $timezonecity";
    $ent_endtime->delete(0,19);
    $ent_endtime->insert('end',$datestr);
}
sub incr_tasknum {
    my $z=int($ent_tasknum->get())+1;
    $ent_tasknum->delete(0,19);
    $ent_tasknum->insert('end',$z);
}
sub upd_db {
    my $dbh=DBI->connect($dbistr,$dbuid,$dbpwd) or die "couldn't connect to db:" . DBI->errstr;
    my $sth=$dbh->prepare("INSERT INTO $dbschema.work(person_name,start_time,end_time,tasknum,prj,church,satisfied) VALUES(?,?,?,?,?,?,?)");
    $sth->execute($ent_name->get(),
                  $ent_starttime->get(),
                  $ent_endtime->get(),
                  $ent_tasknum->get(),
                  $ent_prj->get(),
                  $church,
                  $satisfied);
    $sth->finish;
    #print $ent_tasknum->get() . "\n";
    incr_tasknum();
    $dbh->disconnect();
}
sub upd_ent {
    my $dbh=DBI->connect($dbistr,$dbuid,$dbpwd) or die "couldn't connect to db:" . DBI->errstr;
    my $sth=$dbh->prepare("SELECT MAX($dbschema.work.tasknum) AS t FROM $dbschema.work WHERE $dbschema.work.person_name=? AND $dbschema.work.prj=?");
    $sth->execute($ent_name->get(),
                  $ent_prj->get());
    if (@data=$sth->fetchrow_array()) {
        my $z=$data[0]+1;
        $ent_tasknum->delete(0,19);
        $ent_tasknum->insert('end',$z);
    }
    $sth->finish;
    $dbh->disconnect();
}
sub crt_db {
    my $dbh=DBI->connect($dbistr,$dbuid,$dbpwd) or die "couldn't connect to db:" . DBI->errstr;


    my $sth=$dbh->prepare("CREATE SCHEMA $dbschema");
    $sth->execute();


    my $sth=$dbh->prepare("
    CREATE TABLE $dbschema.work (
      id 		SERIAL,
      person_name	VARCHAR(45) NOT NULL default '',
      start_time 	TIMESTAMP with time zone NOT NULL default '2000-01-01 00:00:00 $timezonecity',
      end_time 	TIMESTAMP with time zone NOT NULL default '2000-01-01 00:00:00 $timezonecity',
      tasknum 	INT DEFAULT NULL,
      prj 		VARCHAR(45) DEFAULT NULL,
      church 	INT NOT NULL DEFAULT '0',
      satisfied	INT NOT NULL DEFAULT '0',
      PRIMARY KEY(id),
      UNIQUE(id)
    )");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workhours AS
	SELECT
		$dbschema.work.id AS id,
		$dbschema.work.person_name AS person_name,
		$dbschema.work.prj AS prj,
		$dbschema.work.tasknum AS tasknum,
		$dbschema.work.start_time,
		to_char($dbschema.work.end_time-$dbschema.work.start_time,'DDD HH24:MI:SS') AS elapsed_,
		$dbschema.work.church AS church,
		$dbschema.work.satisfied AS satisfied
	FROM
		$dbschema.work
	ORDER BY
		$dbschema.work.person_name,
		$dbschema.work.prj,
		$dbschema.work.tasknum,
		$dbschema.work.start_time
    ");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workhourstot AS
	SELECT
		$dbschema.work.person_name AS person_name,
		$dbschema.work.prj AS prj,
		CAST (EXTRACT(HOUR FROM SUM($dbschema.work.end_time-$dbschema.work.start_time)) AS INT) AS hours_,
		CAST (EXTRACT(MINUTE FROM SUM($dbschema.work.end_time-$dbschema.work.start_time)) AS INT) AS minutes_,
		AVG($dbschema.work.church) AS church,
		AVG(satisfied) AS avg_satisfied,
		COUNT(satisfied) AS cnt_satisfied
	FROM
		$dbschema.work
	GROUP BY
		$dbschema.work.person_name,
		$dbschema.work.prj
	ORDER BY
		$dbschema.work.person_name,
		$dbschema.work.prj
    ");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workhourstot_customer AS
	SELECT
		$dbschema.workhourstot.person_name AS person_name,
		CAST (floor((SUM((($dbschema.workhourstot.hours_ * 60) + $dbschema.workhourstot.minutes_)) / 60)) AS INT )  AS hours_,
		(CAST (SUM((($dbschema.workhourstot.hours_ * 60) + $dbschema.workhourstot.minutes_)) AS INT ) % 60) AS minutes_,
		AVG($dbschema.workhourstot.avg_satisfied) AS avg_satisfied
	FROM
		$dbschema.workhourstot
	GROUP BY
		$dbschema.workhourstot.person_name
    ");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workhourstotname AS
	SELECT
		$dbschema.work.person_name AS person_name,
		$dbschema.work.prj AS prj,
		count($dbschema.work.satisfied) AS cnt,
		CAST(EXTRACT(HOUR FROM SUM($dbschema.work.end_time-$dbschema.work.start_time)) AS INT) AS hours_,
		CAST(EXTRACT(MINUTE FROM SUM($dbschema.work.end_time-$dbschema.work.start_time)) AS INT) AS minutes_,
		AVG($dbschema.work.church) AS church,
		AVG($dbschema.work.satisfied) AS satisfied
	FROM
		$dbschema.work
	GROUP BY
		$dbschema.work.person_name,
		$dbschema.work.prj
    ");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workhourstotprj AS
	SELECT
		$dbschema.work.person_name AS person_name,
		$dbschema.work.prj AS prj,
		CAST(EXTRACT(HOUR FROM SUM($dbschema.work.end_time-$dbschema.work.start_time)) AS INT) AS hours_,
		CAST(EXTRACT(MINUTE FROM SUM($dbschema.work.end_time-$dbschema.work.start_time)) AS INT) AS minutes_,
		AVG($dbschema.work.church) AS church,
		AVG($dbschema.work.satisfied) AS satisfied,
		COUNT($dbschema.work.satisfied) AS cnt
	FROM
		$dbschema.work
	GROUP BY
		$dbschema.work.person_name,
		$dbschema.work.prj
    ");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workbyname AS
	SELECT
		$dbschema.work.id AS id,
		$dbschema.work.person_name AS person_name,
		$dbschema.work.prj AS prj,
		$dbschema.work.start_time AS start_time,
		$dbschema.work.end_time AS end_time,
		$dbschema.work.church AS church,
		$dbschema.work.satisfied AS satisfied
	FROM
		$dbschema.work
	ORDER BY
		$dbschema.work.person_name,
		$dbschema.work.start_time
    ");
    $sth->execute();

    $sth=$dbh->prepare("
CREATE OR REPLACE VIEW $dbschema.workbyprj AS
	SELECT
		$dbschema.work.id AS id,
		$dbschema.work.person_name AS person_name,
		$dbschema.work.prj AS prj,
		$dbschema.work.start_time AS start_time,
		$dbschema.work.end_time AS end_time,
		$dbschema.work.church AS church,
		$dbschema.work.satisfied AS satisfied
	FROM
		$dbschema.work
	ORDER BY
		$dbschema.work.prj,
		$dbschema.work.person_name,
		$dbschema.work.start_time
    ");
    $sth->execute();


    $sth->finish;
    $dbh->disconnect();
}
